#"Ready, Set, GO!" sequence
execute if entity @s[scores={startCountdown=..99}] run function parkour_grand_prix:game_logic/1/start_countdown

#If the player is past the starting countdown, increment their timer stuff
execute if entity @s[scores={startCountdown=50..}] run function parkour_grand_prix:game_logic/1/self_timer

#Context-sensitive actionbar display
function parkour_grand_prix:game_logic/1/actionbar_display

#tell nearby checkpoints they should start running functions to test player
execute if entity @s[gamemode=adventure,scores={checkDelay=..0}] positioned ~-3 ~-9 ~-3 run tag @e[tag=checkpoint,tag=!checkAnyY,dx=5,dy=9,dz=5] add foundplayer
execute if entity @s[gamemode=adventure,scores={checkDelay=..0}] positioned ~-3 0 ~-3 run tag @e[tag=checkpoint,tag=checkAnyY,dx=5,dy=255,dz=5] add foundplayer

#do the same for finish lines...
execute if entity @s[gamemode=adventure,scores={checkDelay=..0}] positioned ~-3 ~-9 ~-3 run tag @e[tag=finishline,tag=!finAnyY,dx=5,dy=9,dz=5] add foundplayer
execute if entity @s[gamemode=adventure,scores={checkDelay=..0}] positioned ~-3 0 ~-3 run tag @e[tag=finishline,tag=finAnyY,dx=5,dy=255,dz=5] add foundplayer

#drop structure void or respawn after death, go back to last checkpoint
execute if entity @s[scores={death=10..,hp=1..}] run function parkour_grand_prix:game_logic/1/respawn
scoreboard players add @s[scores={death=1..}] death 1
execute if entity @s[scores={dropSVoid=1..,resetCooldown=0}] run function parkour_grand_prix:game_logic/1/respawn
execute if entity @s[scores={dropSVoid=1..,resetCooldown=1..}] run playsound minecraft:block.note_block.bass master @s ~ ~ ~ 2 1.8
execute if entity @s[scores={dropSVoid=1..,resetCooldown=1..}] run tellraw @s ["",{"text":"[ ! ] You cannot respawn at this time!","bold":"true","color":"red"}]
scoreboard players remove @s[scores={resetCooldown=1..}] resetCooldown 1
scoreboard players set @s[scores={dropSVoid=1..}] dropSVoid 0

#OUT OF BOUNDS, stop running logic
#execute store result score @s pgp_x run data get entity @s Pos[0]
#execute store result score @s pgp_y run data get entity @s Pos[1]
#execute store result score @s pgp_z run data get entity @s Pos[2]
#execute if score @s pgp_x > pgp_max pgp_x run tag @s add pgp_leave
#execute if score @s pgp_y > pgp_max pgp_y run tag @s add pgp_leave
#execute if score @s pgp_z > pgp_max pgp_z run tag @s add pgp_leave
#execute if score @s pgp_x < pgp_min pgp_x run tag @s add pgp_leave
#execute if score @s pgp_y < pgp_min pgp_y run tag @s add pgp_leave
#execute if score @s pgp_z < pgp_min pgp_z run tag @s add pgp_leave
#execute if entity @s[tag=pgp_leave] run function parkour_grand_prix:game_logic/1/player_exit

#drop clock, show pb to self
execute if entity @s[scores={dropClock=1..}] run function parkour_grand_prix:game_logic/1/show_pb

#drop diamond, show current wr
execute if entity @s[scores={dropDiamond=1..}] run function parkour_grand_prix:game_logic/1/show_wr

#drop barrier, restart
scoreboard players set @s[scores={dropBarrier=1..}] startCountdown 0
execute if entity @s[scores={dropBarrier=1..}] run scoreboard players reset @s dropBarrier

#drop door, back to menu
scoreboard players set @s[scores={dropDoor=1..}] join 1
execute if entity @s[scores={dropDoor=1..}] run scoreboard players reset @s dropDoor